local ScarfCharLoaded

addHook("ThinkFrame", do
	if not ScarfCharLoaded and Scarf then
		Scarf.Char["stefan"] = {
			ShowBossBar = true,
			UseScarfHPSystem = true,
			HPName = "Stefan",
			HPNameColor = V_MAGENTAMAP,
			ShowCustomBar = true,
			CustomBar = "STFNBR",
			HpBossBar = "STFNHP",
			ShowBossCard = true,
			IncrementBossHitsFunction = function(mo)
				mo.ko_bosshitscale = min(Scarf.BOSSHITSCALEMAX, ($ or 0) + FRACUNIT)
			end,
			EnemyHitFunction = function(mo, inf, source, damage, damagetype)
				if not (mo and mo.valid) then return end
				if not (source and source.valid) then return end
				if not (source.player and source.player.valid) then return end
				if source.player.powers[pw_flashing] <= Scarf.FLASHINGTICS+15
					source.player.powers[pw_flashing] = Scarf.FLASHINGTICS+15
				end
				mo.koenemybar = $ - 2
				if source.matack > 0
					source.matak_tics = 3*TICRATE
					source.matack = 0
				end
				source.stefanstompcldwn = 0
				source.stefanstomp = false
				source.stefanwhite = 0
				if source.magentathok > 0
					source.state = S_PLAY_SPRING
					P_SetObjectMomZ(source, 8*FRACUNIT, false)
					source.mgnthktics = 3*TICRATE
					source.magentathok = 0
				end
				S_StartSound(mo, sfx_cybdth)
				source.player.pflags = $1 & ~PF_JUMPED
				source.player.pflags = $1 & ~PF_SPINNING
				source.player.pflags = $1 & ~PF_THOKKED
				source.stefanfly = 0
				source.dashfly = 0
				source.stfnslowfall = 0
				Scarf.DamageStyleSystem(mo, 6)
			end,
			BossHitFunction = function(mo, inf, source, damage, damagetype)
				if not (mo and mo.valid) then return end
				if not (source and source.valid) then return end
				if not (source.player and source.player.valid) then return end
				Scarf.IncrementBossHits(source)
				if source.player.powers[pw_flashing] <= Scarf.FLASHINGTICS+15
					source.player.powers[pw_flashing] = Scarf.FLASHINGTICS+15
				end
				mo.bosshp = $ - Scarf.BossHitScale(22, source.ko_bosshitscale, nil, mo.info.spawnhealth)
				if source.matack > 0
					source.matak_tics = 3*TICRATE
					source.matack = 0
				end
				source.stefanstompcldwn = 0
				source.stefanstomp = false
				source.stefanwhite = 0
				if source.magentathok > 0
					source.state = S_PLAY_SPRING
					P_SetObjectMomZ(source, 8*FRACUNIT, false)
					source.mgnthktics = 3*TICRATE
					source.magentathok = 0
				end
				S_StartSound(mo, sfx_cybdth)
				source.player.pflags = $1 & ~PF_JUMPED
				source.player.pflags = $1 & ~PF_SPINNING
				source.player.pflags = $1 & ~PF_THOKKED
				source.stefanfly = 0
				source.dashfly = 0
				source.stfnslowfall = 0
				Scarf.DamageStyleSystem(mo, 6)
			end
		}
		Scarf.BossInfo[MT_EGGMOBILE].voices.chars["stefan"] = "sfx_egstn1"
		Scarf.BossInfo[MT_EGGMOBILE2].voices.chars["stefan"] = "sfx_egstn2"
		Scarf.BossInfo[MT_EGGMOBILE3].voices.chars["stefan"] = "sfx_egstn3"
		Scarf.BossInfo[MT_EGGMOBILE4].voices.chars["stefan"] = "sfx_egstn4"
		Scarf.BossInfo[MT_FANG].voices.chars["stefan"] = "sfx_egstn5"
		Scarf.BossInfo[MT_METALSONIC_BATTLE].voices.chars["stefan"] = "sfx_egstn6"
		Scarf.BossInfo[MT_CYBRAKDEMON].voices.chars["stefan"] = "sfx_egstn7"
		Scarf.BossInfo[MT_BLACKEGGMAN].voices.chars["stefan"] = "sfx_egstn7"
		Scarf.BossInfo[MT_EGGMOBILE].voices.ruschars["stefan"] = "sfx_rustn1"
		Scarf.BossInfo[MT_EGGMOBILE2].voices.ruschars["stefan"] = "sfx_rustn2"
		Scarf.BossInfo[MT_EGGMOBILE3].voices.ruschars["stefan"] = "sfx_rustn3"
		Scarf.BossInfo[MT_EGGMOBILE4].voices.ruschars["stefan"] = "sfx_rustn4"
		Scarf.BossInfo[MT_FANG].voices.ruschars["stefan"] = "sfx_rustn5"
		Scarf.BossInfo[MT_METALSONIC_BATTLE].voices.ruschars["stefan"] = "sfx_rustn6"
		Scarf.BossInfo[MT_CYBRAKDEMON].voices.ruschars["stefan"] = "sfx_rustn7"
		Scarf.BossInfo[MT_BLACKEGGMAN].voices.ruschars["stefan"] = "sfx_rustn7"
		ScarfCharLoaded = true
	end
end)